import logging

logging.basicConfig(level='DEBUG')
logger = logging.getLogger(__name__)


class BZBaseTools:
    ganwuxing = [2, 2, 3, 3, 4, 4, 0, 0, 1, 1]
    zhiwuxing = [1, 4, 2, 2, 4, 3, 3, 4, 0, 0, 4, 1]

    # 当令者旺，令生者相，生令者休，克令者囚，令克者死

    # 季节	月建	   旺	相	休	囚	死
    # 春季	寅卯	   木	火	水	金	土
    # 夏季	巳午	   火	土	木	水	金
    # 秋季	申酉    金	水	土	火	木
    # 冬季	亥子	   水	木	金	土	火
    # 四季	辰未戌丑	土	金	火	木	水

    # 季节   月建        金     水   木  火  土
    # 春季    寅卯        3囚    2休 0旺 1相  4死
    # 夏季    巳午        4死    3囚 2休 0旺  1相
    # 秋季    申酉        0旺    1相 4死 3囚  2休
    # 冬季    亥子        2休    0旺 1相 4死  3囚
    # 四季    辰未戌丑     1相   4死 3囚 2休  0旺

    # 季节   月建        0金     1水 2木 3火 4土
    # 冬季    0子        2休    0旺 1相 4死  3囚
    # 四季    1丑        1相    4死 3囚 2休  0旺
    # 春季    2寅        3囚    2休 0旺 1相  4死
    # 春季    3卯        3囚    2休 0旺 1相  4死
    # 四季    4辰        1相    4死 3囚 2休  0旺
    # 夏季    5巳        4死    3囚 2休 0旺  1相
    # 夏季    6午        4死    3囚 2休 0旺  1相
    # 四季    7未        1相    4死 3囚 2休  0旺
    # 秋季    8申        0旺    1相 4死 3囚  2休
    # 秋季    9酉        0旺    1相 4死 3囚  2休
    # 四季    10戌       1相    4死 3囚 2休  0旺
    # 冬季    11亥       2休    0旺 1相 4死  3囚

    # 横坐标为地支，纵坐标为五行
    # 五行生旺
    WuxingShengwang = [[2, 0, 1, 4, 3], [1, 4, 3, 2, 0], [3, 2, 0, 1, 4],
                       [3, 2, 0, 1, 4], [1, 4, 3, 2, 0], [4, 3, 2, 0, 1],
                       [4, 3, 2, 0, 1], [1, 4, 3, 2, 0], [0, 1, 4, 3, 2],
                       [0, 1, 4, 3, 2], [1, 4, 3, 2, 0], [2, 0, 1, 4, 3]]

    # ["0春季","1夏季","2秋季","3冬季","4四季"]
    # Zhi=["0子", "1丑", "2寅", "3卯", "4辰", "5巳", "6午", "7未", "8申", "9酉", "10戌", "11亥"]
    # 季节
    Jijie = [3, 4, 0, 0, 4, 1, 1, 4, 2, 2, 4, 3]
    """
        0长生 1沐浴 2冠带 3临官 4帝旺 5衰 6病  7死  8墓  9绝 10胎 11养
    甲   亥   子   丑    寅    卯    辰  巳    午   未  申  酉    戌
    乙   午   巳   辰    卯    寅    丑  子    亥   戌  酉  申    未
    丙   寅   卯   辰    巳    午    未  申    酉   戌  亥  子    丑
    丁   酉   申   未    午    巳    辰  卯    寅   丑  子  亥    戌
    戊   寅   卯   辰    巳    午    未  申    酉   戌  亥  子    丑
    己   酉   申   未   午     巳    辰  卯    寅   丑  子  亥    戌
    庚   巳   午   未   申     酉    戌  亥    子   丑  寅   卯   辰
    辛   子   亥   戌   酉     申    未  午    巳   辰  卯   寅   丑
    壬   申   酉   戌   亥     子    丑  寅    卯   辰  巳   午   未
    癸   卯   寅   丑   子     亥    戌  酉    申   未  午   巳   辰
    """

    # 输入tgA，dzB，顺序为Gan，Zhi顺序, 从0开始，如 癸在未，则输入 （9，7）=8 墓 ；丁在午，输入（3，6）=3 临官
    Shierchangsheng = [[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 0],
                       [6, 5, 4, 3, 2, 1, 0, 11, 10, 9, 8, 7],
                       [10, 11, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
                       [9, 8, 7, 6, 5, 4, 3, 2, 1, 0, 11, 10],
                       [10, 11, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9],
                       [9, 8, 7, 6, 5, 4, 3, 2, 1, 0, 11, 10],
                       [7, 8, 9, 10, 11, 0, 1, 2, 3, 4, 5, 6],
                       [0, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1],
                       [4, 5, 6, 7, 8, 9, 10, 11, 0, 1, 2, 3],
                       [3, 2, 1, 0, 11, 10, 9, 8, 7, 6, 5, 4]]
    """ 
    他干 甲   乙   丙  丁   戊   己  庚   辛   壬  癸
    ---------------------------------------------------
    日干 甲 比肩 劫财 食神 伤官 偏财 正财 七杀 正官 偏印 正印
        乙 劫财 比肩 伤官 食神 正财 偏财 正官 七杀 正印 偏印
        丙 偏印 正印 比肩 劫财 食神 伤官 偏财 正财 七杀 正官
        丁 正印 偏印 劫财 比肩 伤官 食神 正财 偏财 正官 七杀
        戊 七杀 正官 偏印 正印 比肩 劫财 食神 伤官 偏财 正财
        己 正官 七杀 正印 偏印 劫财 比肩 伤官 食神 正财 偏财
        庚 偏财 正财 七杀 正官 偏印 正印 比肩 劫财 食神 伤官
        辛 正财 偏财 正官 七杀 正印 偏印 劫财 比肩 伤官 食神
        壬 食神 伤官 偏财 正财 七杀 正官 偏印 正印 比肩 劫财
        癸 伤官 食神 正财 偏财 正官 七杀 正印 偏印 劫财 比肩
    """

    # 天干对应食神，输入tgA，tgB。对应b是a的十神，如（甲，丁）输入为（1，4）=7，丁是甲的伤官。如（）
    ShishenList = [[4, 5, 6, 7, 9, 8, 1, 0, 3, 2],
                   [5, 4, 7, 6, 8, 9, 0, 1, 2, 3],
                   [3, 2, 4, 5, 6, 7, 9, 8, 1, 0],
                   [2, 3, 5, 4, 7, 6, 8, 9, 0, 1],
                   [1, 0, 3, 2, 4, 5, 6, 7, 9, 8],
                   [0, 1, 2, 3, 5, 4, 7, 6, 8, 9],
                   [8, 9, 1, 0, 3, 2, 4, 5, 6, 7],
                   [9, 8, 0, 1, 2, 3, 5, 4, 7, 6],
                   [6, 7, 9, 8, 1, 0, 3, 2, 4, 5],
                   [7, 6, 8, 9, 0, 1, 2, 3, 5, 4]]

    DzinTg = [[9], [5, 9, 7], [0, 2, 4], [1], [4, 1, 9], [2, 6, 4], [3, 5],
              [5, 3, 1], [6, 8, 4], [7], [4, 7, 3], [8, 0]]
    """
        for x in DzinTg[8]:
            print(x, end=" ")
    """

    # 得到两个天干之间的十神关系
    def getShishenName(self, tg1, tg2):
        """
        得到两个天干之间的十神关系

        :param tg1:
        :param tg2:
        :return:
        """
        value = BZBaseTools.ShishenList[tg1][tg2]
        logger.debug(value)
        return value

    """
    比如从n个元素选取k个出来组合，根据数学知识可知总共组合数为Cnk。
    
    代码实现的基本思想就是，先选取一个元素出来，接下来任务就相当于是对后面的元素选取k-1个出来组合。这样就形成了递归调用！
    """

    def Combinations(self, li, k):
        """
        比如从n个元素选取k个出来组合，根据数学知识可知总共组合数为Cnk。
        代码实现的基本思想就是，先选取一个元素出来，接下来任务就相当于是对后面的元素选取k-1个出来组合。这样就形成了递归调用！

        :param li:
        :param k:
        :return:
        """
        n = len(li)
        result = []  # To Place Combination result

        for i in range(n - k + 1):
            if k > 1:
                new_l = li[i + 1:]
                comb = self.Combinations(new_l, k - 1)

                for item in comb:
                    item.insert(0, li[i])
                    result.append(item)
            else:
                result.append([li[i]])

        # return result, len(result)  可以返回两个参数！
        logger.debug(result)
        return result
